import { SlashCommandBuilder, EmbedBuilder, PermissionsBitField } from 'discord.js';

export default {
  data: new SlashCommandBuilder()
    .setName('clear')
    .setDescription('Deletes chosen amount of messages')
    .addIntegerOption((option) => {
      option.setName('amount')
        .setDescription('amount of messages to delete')
        .setMinValue(1)
        .setMaxValue(25)
        .setRequired(true);
      return option;
    })
    .setDMPermission(false)
    .setDefaultMemberPermissions(PermissionsBitField.Flags['ManageMessages']),
  async execute(interaction, api) {
    const amount = interaction.options.getInteger('amount');
    await interaction.channel.bulkDelete(amount);

    const embed = new EmbedBuilder()
      .setTitle(`Deleted ${amount} messages in total`)
      .setColor(interaction.member.displayColor);
    await interaction.reply({ embeds: [ embed ] });
    setTimeout(async () => {
      try {
        await interaction.deleteReply();
      } catch (e) {}
    }, 3000);
  }
};
