import Discord from 'discord.js';

const PresenceHandler = class {
  constructor(content, activityType, status) {
    this.content = content;
    this.activityType = activityType;
    this.status = status;
  }

  async init(client) {
    try {
      const type = this.activityType === 'LISTENING' ? Discord.ActivityType.Listening :
        this.activityType === 'WATCHING' ? Discord.ActivityType.Watching :
          this.activityType === 'STREAMING' ? Discord.ActivityType.Streaming :
            this.activityType === 'PLAYING' ? Discord.ActivityType.Playing :
              this.activityType === 'COMPETING' ? Discord.ActivityType.Competing :
                this.activityType === 'CUSTOM' ? Discord.ActivityType.Custom : undefined;

      const presencePayload = {
        status: this.status
      };

      if (type != undefined) {
        presencePayload.activities = [{
          name: this.content,
          type: type
        }];
      }

      await client.user.setPresence(presencePayload);

      return { status: this.status, content: this.content, type: type };
    } catch (err) {
      throw err;
    }
  }
};

export default PresenceHandler;
